'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reconfigureIfNecessary = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends4 = require('babel-runtime/helpers/extends');

var _extends5 = _interopRequireDefault(_extends4);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var reconfigureIfNecessary = exports.reconfigureIfNecessary = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(configProp) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(configWhichNeedsReconfigure.indexOf(configProp) === -1)) {
              _context.next = 2;
              break;
            }

            return _context.abrupt('return');

          case 2:
            _context.next = 4;
            return (0, _reconfigure.reconfigureAllNavies)();

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function reconfigureIfNecessary(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _config = require('../../config');

var _errors = require('../../errors');

var _reconfigure = require('../util/reconfigure');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NAME_MAP = {
  'default-navy': 'defaultNavy',
  'external-ip': 'externalIP'
};

var configWhichNeedsReconfigure = ['externalIP'];

_commander2.default.command('set <key> <value>').description('Sets the given config key').action(function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(key, value) {
    var configProp;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            configProp = NAME_MAP[key];

            if (configProp) {
              _context2.next = 3;
              break;
            }

            throw new _errors.NavyError('Invalid config key: ' + key);

          case 3:
            _context2.t0 = _config.setConfig;
            _context2.t1 = _extends5.default;
            _context2.t2 = {};
            _context2.next = 8;
            return (0, _config.getConfig)();

          case 8:
            _context2.t3 = _context2.sent;
            _context2.t4 = (0, _defineProperty3.default)({}, configProp, value);
            _context2.t5 = (0, _context2.t1)(_context2.t2, _context2.t3, _context2.t4);
            _context2.next = 13;
            return (0, _context2.t0)(_context2.t5);

          case 13:
            _context2.next = 15;
            return reconfigureIfNecessary(configProp);

          case 15:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function (_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}());

_commander2.default.command('get <key>').description('Gets the given config by key').action(function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(key) {
    var config;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (NAME_MAP[key]) {
              _context3.next = 2;
              break;
            }

            throw new _errors.NavyError('Invalid config key: ' + key);

          case 2:
            _context3.next = 4;
            return (0, _config.getConfig)();

          case 4:
            config = _context3.sent;


            console.log(config[NAME_MAP[key]]);

          case 6:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function (_x4) {
    return _ref3.apply(this, arguments);
  };
}());

_commander2.default.command('rm <key>').description('Removes the current config value').action(function () {
  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(key) {
    var configProp;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            configProp = NAME_MAP[key];

            if (configProp) {
              _context4.next = 3;
              break;
            }

            throw new _errors.NavyError('Invalid config key: ' + key);

          case 3:
            _context4.t0 = _config.setConfig;
            _context4.t1 = _extends5.default;
            _context4.t2 = {};
            _context4.next = 8;
            return (0, _config.getConfig)();

          case 8:
            _context4.t3 = _context4.sent;
            _context4.t4 = (0, _defineProperty3.default)({}, configProp, null);
            _context4.t5 = (0, _context4.t1)(_context4.t2, _context4.t3, _context4.t4);
            _context4.next = 13;
            return (0, _context4.t0)(_context4.t5);

          case 13:
            _context4.next = 15;
            return reconfigureIfNecessary(configProp);

          case 15:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function (_x5) {
    return _ref4.apply(this, arguments);
  };
}());

_commander2.default.command('ls').description('Lists all of the Navy config keys and values that have been set').action((0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
  var configKeys, config;
  return _regenerator2.default.wrap(function _callee5$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          configKeys = (0, _keys2.default)(NAME_MAP);
          _context5.next = 3;
          return (0, _config.getConfig)();

        case 3:
          config = _context5.sent;


          console.log(configKeys.map(function (key) {
            return key + '=' + (config[NAME_MAP[key]] != null ? config[NAME_MAP[key]] : 'null');
          }).join('\n'));

        case 5:
        case 'end':
          return _context5.stop();
      }
    }
  }, _callee5, undefined);
})));

_commander2.default.command('json').description('Dumps out all Navy config as JSON').action((0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
  return _regenerator2.default.wrap(function _callee6$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:
          _context6.t0 = console;
          _context6.t1 = _stringify2.default;
          _context6.next = 4;
          return (0, _config.getConfig)();

        case 4:
          _context6.t2 = _context6.sent;
          _context6.t3 = (0, _context6.t1)(_context6.t2, null, 2);

          _context6.t0.log.call(_context6.t0, _context6.t3);

        case 7:
        case 'end':
          return _context6.stop();
      }
    }
  }, _callee6, undefined);
})));

process.on('unhandledRejection', function (err) {
  if (err instanceof _errors.NavyError) {
    err.prettyPrint();
  } else {
    console.error(err.stack);
  }
});

_commander2.default.parse(process.argv);

if (_commander2.default.args.length === 0) {
  _commander2.default.help();
}