'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _ = require('../');

var _errors = require('../errors');

var _dockerClient = require('../util/docker-client');

var _dockerClient2 = _interopRequireDefault(_dockerClient);

var _navyrc = require('../util/navyrc');

var _navyrc2 = _interopRequireDefault(_navyrc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(service, opts) {
    var navy, cwd, navyRc, mounts, state, container, containerId, containerObj;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            navy = (0, _.getNavy)(opts.navy);
            cwd = process.cwd();
            _context.next = 4;
            return (0, _navyrc2.default)(cwd);

          case 4:
            navyRc = _context.sent;

            if (!(!navyRc || !navyRc.services)) {
              _context.next = 7;
              break;
            }

            throw new _errors.NavyError('No valid .navyrc file was found in "' + cwd + '"');

          case 7:
            if (navyRc.develop) {
              _context.next = 9;
              break;
            }

            throw new _errors.NavyError('No develop mounts found in .navyrc');

          case 9:
            if (!(navyRc.services.length > 1 && !service)) {
              _context.next = 11;
              break;
            }

            throw new _errors.NavyError('Multiple service mappings are defined in .navyrc, you need to explicitly specify what service to develop');

          case 11:

            if (!service) service = navyRc.services[0];

            if (!(navyRc.services.indexOf(service) === -1)) {
              _context.next = 14;
              break;
            }

            throw new _errors.NavyError('Service "' + service + '" is not a valid development target');

          case 14:
            mounts = {};

            (0, _keys2.default)(navyRc.develop.mounts).forEach(function (localPath) {
              return mounts[_path2.default.resolve(localPath)] = navyRc.develop.mounts[localPath];
            });

            _context.next = 18;
            return navy.getState();

          case 18:
            _context.t0 = _context.sent;

            if (_context.t0) {
              _context.next = 21;
              break;
            }

            _context.t0 = {};

          case 21:
            state = _context.t0;
            _context.next = 24;
            return navy.saveState((0, _extends4.default)({}, state, {
              services: (0, _extends4.default)({}, state.services, (0, _defineProperty3.default)({}, service, (0, _extends4.default)({}, (state.services || {})[service], {
                _develop: {
                  mounts: mounts,
                  command: navyRc.develop.command
                }
              })))
            }));

          case 24:
            _context.next = 26;
            return navy.emitAsync('cli.develop.beforeLaunch');

          case 26:
            _context.next = 28;
            return navy.kill([service]);

          case 28:
            _context.next = 30;
            return navy.launch([service], { noDeps: true });

          case 30:

            console.log('\uD83D\uDEA7  ' + service + ' has now restarted in development \uD83D\uDEA7');
            console.log(_chalk2.default.dim('-----------'));
            console.log();

            _context.next = 35;
            return navy.ps();

          case 35:
            _context.t1 = function (_service) {
              return _service.name === service;
            };

            container = _context.sent.filter(_context.t1)[0];


            (0, _invariant2.default)(container, 'DEVELOP_NO_CONTAINER_ID: Could not determine container ID for log attachment');

            containerId = container.id;
            containerObj = _dockerClient2.default.getContainer(containerId);

            containerObj.attach({ stream: true, stdout: true, stderr: true }).then(function (stream) {
              return containerObj.modem.demuxStream(stream, process.stdout, process.stderr);
            }).catch(function () {
              console.log();
              console.log(_chalk2.default.dim('-------> ' + service + ' exited'));
              console.log();
            });

          case 41:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports.default;