'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _ = require('../');

var _table = require('../util/table');

var _table2 = _interopRequireDefault(_table);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getStatus(service, state) {
  var health = service.raw && service.raw.State.Health;

  if (!health) {
    return '-';
  }

  var statusString = health.Status === 'healthy' ? _chalk2.default.green('✔ Healthy') : _chalk2.default.red('• Unhealthy');

  return statusString;
}

function getHistory(service, state) {
  var health = service.raw && service.raw.State.Health;

  if (!health) {
    return '-';
  }

  var history = health.Log;

  return history.map(function (record) {
    return record.ExitCode === 0 ? _chalk2.default.green('█') : _chalk2.default.red('x');
  }).join(' ');
}

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(opts) {
    var navy, ps, state;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            navy = (0, _.getNavy)(opts.navy);
            _context.next = 3;
            return navy.ps();

          case 3:
            ps = _context.sent;
            _context.next = 6;
            return navy.getState();

          case 6:
            state = _context.sent;


            console.log((0, _table2.default)([['NAME', 'STATUS', 'HISTORY']].concat((0, _toConsumableArray3.default)(ps.map(function (service) {
              return [service.name, getStatus(service, state), getHistory(service, state)];
            })))));

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports.default;