'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _util = require('./util');

var _driverLogging = require('../driver-logging');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SELECTED_WEIGHT = 100; // make sure selected services appear at the top

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(services, opts) {
    var navy, navyFile, serviceNames, launchedServiceNames, selectedServiceNames, choices, _ref2, selectedServices;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _util.getOrInitialiseNavy)(opts.navy);

          case 2:
            navy = _context.sent;
            _context.next = 5;
            return navy.getNavyFile();

          case 5:
            _context.t0 = _context.sent;

            if (_context.t0) {
              _context.next = 8;
              break;
            }

            _context.t0 = {};

          case 8:
            navyFile = _context.t0;
            _context.next = 11;
            return navy.ensurePluginsLoaded();

          case 11:
            _context.next = 13;
            return navy.getAvailableServiceNames();

          case 13:
            serviceNames = _context.sent;
            _context.next = 16;
            return navy.getLaunchedServiceNames();

          case 16:
            launchedServiceNames = _context.sent;
            selectedServiceNames = launchedServiceNames.length > 0 ? launchedServiceNames : navyFile.launchDefaults || [];

            if (!(!services || services.length === 0)) {
              _context.next = 25;
              break;
            }

            choices = serviceNames.sort(function (name) {
              return selectedServiceNames.indexOf(name) === -1 ? SELECTED_WEIGHT : -1;
            }).map(function (name) {
              return {
                name: name,
                checked: selectedServiceNames.indexOf(name) !== -1
              };
            });
            _context.next = 22;
            return _inquirer2.default.prompt([{
              type: 'checkbox',
              message: 'Select services that you\'d like to bring up',
              name: 'services',
              choices: choices
            }]);

          case 22:
            _ref2 = _context.sent;
            selectedServices = _ref2.services;


            services = selectedServices;

          case 25:
            if (!(services.length === 0)) {
              _context.next = 27;
              break;
            }

            return _context.abrupt('return');

          case 27:
            _context.next = 29;
            return navy.emitAsync('cli.before.launch');

          case 29:

            (0, _driverLogging.startDriverLogging)('Launching services...');
            _context.next = 32;
            return navy.launch(services);

          case 32:
            (0, _driverLogging.stopDriverLogging)();

          case 33:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports.default;