'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _ = require('../');

var _errors = require('../errors');

var _navyrc = require('../util/navyrc');

var _navyrc2 = _interopRequireDefault(_navyrc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(service, opts) {
    var navy, cwd, navyRc, state;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            navy = (0, _.getNavy)(opts.navy);
            cwd = process.cwd();
            _context.next = 4;
            return (0, _navyrc2.default)(cwd);

          case 4:
            navyRc = _context.sent;

            if (!(navyRc && !navyRc.services)) {
              _context.next = 7;
              break;
            }

            throw new _errors.NavyError('No valid .navyrc file was found in "' + cwd + '"');

          case 7:
            if (!(navyRc && navyRc.services.length > 1 && !service)) {
              _context.next = 9;
              break;
            }

            throw new _errors.NavyError('Multiple service mappings are defined in .navyrc, you need to explicitly specify what service to develop');

          case 9:

            if (navyRc && !service) {
              service = navyRc.services[0];
            }

            _context.next = 12;
            return navy.getState();

          case 12:
            _context.t0 = _context.sent;

            if (_context.t0) {
              _context.next = 15;
              break;
            }

            _context.t0 = {};

          case 15:
            state = _context.t0;

            if (!(!state || !state.services || !state.services[service] || !state.services[service]._develop)) {
              _context.next = 18;
              break;
            }

            return _context.abrupt('return', console.log(_chalk2.default.dim('Nothing to do, ' + service + ' is not in development')));

          case 18:
            _context.next = 20;
            return navy.saveState((0, _extends4.default)({}, state, {
              services: (0, _extends4.default)({}, state.services, (0, _defineProperty3.default)({}, service, (0, _extends4.default)({}, (state.services || {})[service], {
                _develop: undefined
              })))
            }));

          case 20:
            _context.next = 22;
            return navy.kill([service]);

          case 22:
            _context.next = 24;
            return navy.relaunch({ noDeps: true });

          case 24:

            console.log(service + ' is no longer in development');

          case 25:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports.default;