'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _ = require('../');

var _driverLogging = require('../driver-logging');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(opts) {
    var navy, configProvider;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            navy = (0, _.getNavy)(opts.navy);
            _context.next = 3;
            return navy.getConfigProvider();

          case 3:
            configProvider = _context.sent;


            (0, _invariant2.default)(configProvider, 'NO_CONFIG_PROVIDER: Couldn\'t determine config provider for navy %s', navy.name);

            _context.next = 7;
            return configProvider.refreshConfig();

          case 7:

            (0, _driverLogging.startDriverLogging)('Ensuring services are up to date...');
            _context.next = 10;
            return navy.reconfigure();

          case 10:
            (0, _driverLogging.stopDriverLogging)();

            console.log(_chalk2.default.green('Config refreshed for Navy "' + opts.navy + '"'));

          case 12:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports.default;