'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _ = require('../');

var _table = require('../util/table');

var _table2 = _interopRequireDefault(_table);

var _config = require('../config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function formatNavyName(navy, defaultNavy) {
  if (navy.name === defaultNavy) {
    return navy.name + ' ' + _chalk2.default.cyan('(default)');
  }

  return navy.name;
}

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(opts) {
    var _this = this;

    var navies, config, defaultNavy, rows;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return (0, _.getLaunchedNavies)();

          case 2:
            navies = _context3.sent;

            if (!opts.json) {
              _context3.next = 11;
              break;
            }

            _context3.t0 = console;
            _context3.t1 = _stringify2.default;
            _context3.next = 8;
            return _promise2.default.all(navies.map(function () {
              var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(navy) {
                var ps, state, configProvider, isActive;
                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return navy.ps();

                      case 2:
                        ps = _context.sent;
                        _context.next = 5;
                        return navy.getState();

                      case 5:
                        state = _context.sent;
                        _context.next = 8;
                        return navy.getConfigProvider();

                      case 8:
                        configProvider = _context.sent;
                        isActive = ps.reduce(function (active, service) {
                          return active || service.status === 'running';
                        }, false);
                        _context.t0 = navy.name;
                        _context.t1 = isActive;
                        _context.t2 = ps;
                        _context.t3 = state;
                        _context.t4 = state.configProvider;
                        _context.next = 17;
                        return configProvider.getLocationDisplayName();

                      case 17:
                        _context.t5 = _context.sent;
                        _context.next = 20;
                        return navy.url('[service]');

                      case 20:
                        _context.t6 = _context.sent;
                        return _context.abrupt('return', {
                          name: _context.t0,
                          isActive: _context.t1,
                          services: _context.t2,
                          state: _context.t3,
                          configProvider: _context.t4,
                          configLocation: _context.t5,
                          url: _context.t6
                        });

                      case 22:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function (_x2) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 8:
            _context3.t2 = _context3.sent;
            _context3.t3 = (0, _context3.t1)(_context3.t2, null, 2);
            return _context3.abrupt('return', _context3.t0.log.call(_context3.t0, _context3.t3));

          case 11:
            _context3.next = 13;
            return (0, _config.getConfig)();

          case 13:
            config = _context3.sent;
            defaultNavy = config.defaultNavy;
            _context3.next = 17;
            return _promise2.default.all(navies.map(function () {
              var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(navy) {
                var ps, state, configProvider, isActive;
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.next = 2;
                        return navy.ps();

                      case 2:
                        ps = _context2.sent;
                        _context2.next = 5;
                        return navy.getState();

                      case 5:
                        state = _context2.sent;
                        _context2.next = 8;
                        return navy.getConfigProvider();

                      case 8:
                        configProvider = _context2.sent;
                        isActive = ps.reduce(function (active, service) {
                          return active || service.status === 'running';
                        }, false);
                        _context2.t0 = formatNavyName(navy, defaultNavy);
                        _context2.t1 = isActive ? _chalk2.default.green('yes') : _chalk2.default.red('no');
                        _context2.t2 = ps.length.toString();
                        _context2.t3 = state.configProvider;
                        _context2.next = 16;
                        return configProvider.getLocationDisplayName();

                      case 16:
                        _context2.t4 = _context2.sent;
                        _context2.next = 19;
                        return navy.url(_chalk2.default.dim('service'));

                      case 19:
                        _context2.t5 = _context2.sent;
                        return _context2.abrupt('return', [_context2.t0, _context2.t1, _context2.t2, _context2.t3, _context2.t4, _context2.t5]);

                      case 21:
                      case 'end':
                        return _context2.stop();
                    }
                  }
                }, _callee2, _this);
              }));

              return function (_x3) {
                return _ref3.apply(this, arguments);
              };
            }()));

          case 17:
            rows = _context3.sent;


            console.log((0, _table2.default)([['NAME', 'ACTIVE', 'SERVICES', 'CONFIG PROVIDER', 'CONFIG LOCATION', 'URL']].concat((0, _toConsumableArray3.default)(rows))));

          case 19:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports.default;