'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _readline = require('readline');

var _readline2 = _interopRequireDefault(_readline);

var _cliSpinners = require('cli-spinners');

var _ = require('../');

var _table = require('../util/table');

var _table2 = _interopRequireDefault(_table);

var _hasUpdate = require('../util/has-update');

var _hasUpdate2 = _interopRequireDefault(_hasUpdate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('navy:updates');

var spinnerIndex = 0;
var spinnerFrame = _cliSpinners.dots.frames[0];

function renderStatus(status) {
  if (status == null) {
    return _chalk2.default.yellow(spinnerFrame) + ' ' + _chalk2.default.dim('Checking...');
  } else if (status === true) {
    return _chalk2.default.yellow('• Update available');
  } else if (status === 'UNKNOWN_REMOTE') {
    return _chalk2.default.red('• Not found');
  } else if (status === 'UNKNOWN_ERROR') {
    return _chalk2.default.red('• Internal error');
  } else if (status === 'NO_IMAGE') {
    return _chalk2.default.red('• No image for service');
  } else {
    return _chalk2.default.green('✔ Up to date');
  }
}

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(opts) {
    var _this = this;

    var navy, navyFile, ps, updateStatus, drawnLines, draw, redraw, spinner;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            redraw = function redraw() {
              _readline2.default.clearLine(process.stdout, 0);
              _readline2.default.cursorTo(process.stdout, 0);

              for (var i = 0; i < drawnLines; i++) {
                _readline2.default.moveCursor(process.stdout, 0, -1);
                _readline2.default.clearLine(process.stdout, 0);
              }

              draw();
            };

            draw = function draw() {
              drawnLines = 0;

              var buffer = (0, _table2.default)([['NAME', 'IMAGE', 'UPDATES']].concat((0, _toConsumableArray3.default)(ps.map(function (service) {
                return [service.name, service.image, renderStatus(updateStatus[service.id])];
              }))));

              drawnLines = buffer.split('\n').length;
              console.log(buffer);
            };

            navy = (0, _.getNavy)(opts.navy);
            _context2.next = 5;
            return navy.getNavyFile();

          case 5:
            navyFile = _context2.sent;
            _context2.next = 8;
            return navy.ps();

          case 8:
            ps = _context2.sent;
            updateStatus = {};
            drawnLines = 0;
            spinner = setInterval(function () {
              spinnerIndex++;

              if (spinnerIndex >= _cliSpinners.dots.frames.length) {
                spinnerIndex = 0;
              }

              spinnerFrame = _cliSpinners.dots.frames[spinnerIndex];

              redraw();
            }, _cliSpinners.dots.interval);


            draw();

            _context2.next = 15;
            return _promise2.default.all(ps.map(function () {
              var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(service) {
                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.prev = 0;

                        if (!(!service || !service.raw || !service.raw.Image)) {
                          _context.next = 3;
                          break;
                        }

                        return _context.abrupt('return', updateStatus[service.id] = 'NO_IMAGE');

                      case 3:
                        _context.next = 5;
                        return (0, _hasUpdate2.default)(service.image, service.raw.Image, navyFile);

                      case 5:
                        updateStatus[service.id] = _context.sent;
                        _context.next = 12;
                        break;

                      case 8:
                        _context.prev = 8;
                        _context.t0 = _context['catch'](0);

                        debug('Error checking update for', service.name, _context.t0.stack || _context.t0.message);
                        updateStatus[service.id] = 'UNKNOWN_ERROR';

                      case 12:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this, [[0, 8]]);
              }));

              return function (_x2) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 15:

            redraw();

            clearInterval(spinner);

          case 17:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports.default;