'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.importNavy = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var importNavy = exports.importNavy = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(navy, initialiseOpts) {
    var key;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return navy.isInitialised();

          case 2:
            if (!_context.sent) {
              _context.next = 4;
              break;
            }

            throw new _errors.NavyError('Navy "' + navy.name + '" has already been imported and initialised.');

          case 4:
            _context.next = 6;
            return navy.initialise(initialiseOpts);

          case 6:
            _context.next = 8;
            return navy.ensurePluginsLoaded();

          case 8:
            _context.next = 10;
            return navy.emitAsync('cli.import');

          case 10:

            (0, _driverLogging.startDriverLogging)('Ensuring services are up to date...');
            _context.next = 13;
            return navy.relaunch();

          case 13:
            (0, _driverLogging.stopDriverLogging)();

            console.log();
            console.log(_chalk2.default.green(' Navy "' + _chalk2.default.white.bold(navy.name) + '" has now been imported and initialised. \uD83C\uDF89'));
            console.log();

            for (key in initialiseOpts) {
              if (OPTION_LABEL_MAP[key]) {
                console.log(' ' + _chalk2.default.bold(OPTION_LABEL_MAP[key]) + ': ' + _chalk2.default.dim(initialiseOpts[key]));
              }
            }

            console.log();

          case 19:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function importNavy(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _driverLogging = require('../../driver-logging');

var _errors = require('../../errors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var OPTION_LABEL_MAP = {
  configProvider: 'Provider',
  path: 'Directory',
  npmPackage: 'NPM Package'
};