'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _readline = require('readline');

var _readline2 = _interopRequireDefault(_readline);

var _cliSpinners = require('cli-spinners');

var _ = require('../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var spinnerIndex = 0;
var spinnerFrame = _cliSpinners.dots.frames[0];

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(services, opts) {
    var navy, servicesToCheck, healthyStatus, drawnLines, draw, redraw, spinner;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            redraw = function redraw() {
              _readline2.default.clearLine(process.stdout, 0);
              _readline2.default.cursorTo(process.stdout, 0);

              for (var i = 0; i < drawnLines; i++) {
                _readline2.default.moveCursor(process.stdout, 0, -1);
                _readline2.default.clearLine(process.stdout, 0);
              }

              draw();
            };

            draw = function draw() {
              drawnLines = 0;

              if (healthyStatus.length === 0) {
                console.log('Waiting');
                drawnLines = 1;
                return;
              }

              var lines = healthyStatus.map(function (service) {
                return (service.health !== 'healthy' ? _chalk2.default.yellow(spinnerFrame) : _chalk2.default.green('✔')) + ' ' + service.service;
              });

              drawnLines = lines.length;
              console.log(lines.join('\n'));
            };

            navy = (0, _.getNavy)(opts.navy);
            servicesToCheck = services.length === 0 ? undefined : services;

            if (process.stdout.isTTY) {
              _context.next = 9;
              break;
            }

            _context.next = 7;
            return navy.waitForHealthy(servicesToCheck);

          case 7:
            console.log('Now available');
            return _context.abrupt('return');

          case 9:
            healthyStatus = [];
            drawnLines = 0;
            spinner = setInterval(function () {
              spinnerIndex++;

              if (spinnerIndex >= _cliSpinners.dots.frames.length) {
                spinnerIndex = 0;
              }

              spinnerFrame = _cliSpinners.dots.frames[spinnerIndex];

              redraw();
            }, _cliSpinners.dots.interval);


            draw();

            _context.next = 15;
            return navy.waitForHealthy(servicesToCheck, function (servicesHealth) {
              return healthyStatus = servicesHealth;
            });

          case 15:

            redraw();

            clearInterval(spinner);

          case 17:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports.default;