'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getImportOptionsForCLI = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var getImportOptionsForCLI = exports.getImportOptionsForCLI = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(opts) {
    var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, provider, optionsFromProvider;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context.prev = 3;
            _iterator = (0, _getIterator3.default)(PROVIDERS);

          case 5:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context.next = 15;
              break;
            }

            provider = _step.value;
            _context.next = 9;
            return provider.getImportOptionsForCLI(opts);

          case 9:
            optionsFromProvider = _context.sent;

            if (!optionsFromProvider) {
              _context.next = 12;
              break;
            }

            return _context.abrupt('return', optionsFromProvider);

          case 12:
            _iteratorNormalCompletion = true;
            _context.next = 5;
            break;

          case 15:
            _context.next = 21;
            break;

          case 17:
            _context.prev = 17;
            _context.t0 = _context['catch'](3);
            _didIteratorError = true;
            _iteratorError = _context.t0;

          case 21:
            _context.prev = 21;
            _context.prev = 22;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 24:
            _context.prev = 24;

            if (!_didIteratorError) {
              _context.next = 27;
              break;
            }

            throw _iteratorError;

          case 27:
            return _context.finish(24);

          case 28:
            return _context.finish(21);

          case 29:

            (0, _invariant2.default)(false, 'CLI_IMPORT_RESOLVE_OPTIONS_ERR: Could not resolve import options from CLI arguments');

          case 30:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[3, 17, 21, 29], [22,, 24, 28]]);
  }));

  return function getImportOptionsForCLI(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.resolveConfigProviderFromName = resolveConfigProviderFromName;
exports.getImportCommandLineOptions = getImportCommandLineOptions;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _filesystem = require('./config-providers/filesystem');

var _filesystem2 = _interopRequireDefault(_filesystem);

var _npm = require('./config-providers/npm');

var _npm2 = _interopRequireDefault(_npm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PROVIDERS = [_npm2.default, _filesystem2.default];

function resolveConfigProviderFromName(providerName) {
  switch (providerName) {
    case 'filesystem':
      return _filesystem2.default;
    case 'npm':
      return _npm2.default;
  }

  return null;
}

function getImportCommandLineOptions() {
  return PROVIDERS.reduce(function (arr, provider) {
    return [].concat((0, _toConsumableArray3.default)(arr), (0, _toConsumableArray3.default)(provider.importCliOptions));
  }, []);
}