'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var cwdHasValidDockerComposeConfig = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return (0, _execAsync.execAsync)('docker-compose', ['config'], null, { maxBuffer: Infinity, cwd: process.cwd() });

          case 3:
            _context.next = 8;
            break;

          case 5:
            _context.prev = 5;
            _context.t0 = _context['catch'](0);
            return _context.abrupt('return', false);

          case 8:
            return _context.abrupt('return', true);

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 5]]);
  }));

  return function cwdHasValidDockerComposeConfig() {
    return _ref.apply(this, arguments);
  };
}();

exports.default = createFileSystemConfigProvider;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _fs = require('../../util/fs');

var _fs2 = _interopRequireDefault(_fs);

var _execAsync = require('../../util/exec-async');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createFileSystemConfigProvider(navy) {
  return {
    getNavyPath: function getNavyPath() {
      var _this = this;

      return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var envState;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return navy.getState();

              case 2:
                envState = _context2.sent;


                (0, _invariant2.default)(!!envState, 'STATE_NONEXISTANT: State doesn\'t exist for navy %s', navy.name);
                (0, _invariant2.default)(!!envState.path, 'FILESYSTEM_PROVIDER_REQUIRES_PATH: File system config provider requires a path for %s', navy.name);

                _context2.prev = 5;
                _context2.next = 8;
                return _fs2.default.statAsync(envState.path);

              case 8:
                _context2.next = 13;
                break;

              case 10:
                _context2.prev = 10;
                _context2.t0 = _context2['catch'](5);

                (0, _invariant2.default)(false, 'FILESYSTEM_PROVIDER_INVALID_PATH: Invalid path given to navy: %s', navy.name);

              case 13:
                return _context2.abrupt('return', envState.path);

              case 14:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, _this, [[5, 10]]);
      }))();
    },
    getNavyFilePath: function getNavyFilePath() {
      var _this2 = this;

      return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.t0 = _path2.default;
                _context3.next = 3;
                return _this2.getNavyPath();

              case 3:
                _context3.t1 = _context3.sent;
                return _context3.abrupt('return', _context3.t0.join.call(_context3.t0, _context3.t1, 'Navyfile.js'));

              case 5:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, _this2);
      }))();
    },
    refreshConfig: function refreshConfig() {
      var _this3 = this;

      return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', false);

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, _this3);
      }))();
    },
    getLocationDisplayName: function getLocationDisplayName() {
      var _this4 = this;

      return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        var envState;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return navy.getState();

              case 2:
                envState = _context5.sent;


                (0, _invariant2.default)(!!envState, 'STATE_NONEXISTANT: State doesn\'t exist for navy %s', navy.name);

                return _context5.abrupt('return', envState.path);

              case 5:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, _this4);
      }))();
    },
    isDangling: function isDangling() {
      var _this5 = this;

      return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
        var envState;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return navy.getState();

              case 2:
                envState = _context6.sent;

                if (!(!envState || !envState.path)) {
                  _context6.next = 5;
                  break;
                }

                return _context6.abrupt('return', true);

              case 5:
                _context6.prev = 5;
                _context6.next = 8;
                return _fs2.default.statAsync(envState.path);

              case 8:
                _context6.next = 13;
                break;

              case 10:
                _context6.prev = 10;
                _context6.t0 = _context6['catch'](5);
                return _context6.abrupt('return', true);

              case 13:
                return _context6.abrupt('return', false);

              case 14:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, _this5, [[5, 10]]);
      }))();
    }
  };
}

createFileSystemConfigProvider.importCliOptions = [];

createFileSystemConfigProvider.getImportOptionsForCLI = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(opts) {
    var hasValidComposeConfig;
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return cwdHasValidDockerComposeConfig();

          case 2:
            hasValidComposeConfig = _context7.sent;


            (0, _invariant2.default)(hasValidComposeConfig, 'NO_DOCKER_COMPOSE_FILE: No docker-compose.yml (or valid Docker Compose config) found');

            return _context7.abrupt('return', {
              configProvider: 'filesystem',
              path: process.cwd()
            });

          case 5:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, undefined);
  }));

  return function (_x) {
    return _ref2.apply(this, arguments);
  };
}();
module.exports = exports.default;