'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var tryAndInstall = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(pkgName) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return mkdirp(nodeModulesPath);

          case 2:
            _context.prev = 2;

            // $FlowIgnore some weird bug with execSync
            (0, _child_process.execSync)('npm info ' + pkgName + ' name', { stdio: 'ignore' });
            _context.next = 9;
            break;

          case 6:
            _context.prev = 6;
            _context.t0 = _context['catch'](2);
            throw new Error('Package "' + pkgName + '" not found or unreachable');

          case 9:

            // $FlowIgnore some weird bug with execSync
            (0, _child_process.execSync)('npm i ' + pkgName, { stdio: 'inherit', cwd: npmContext });

          case 10:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[2, 6]]);
  }));

  return function tryAndInstall(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = createNpmConfigProvider;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _child_process = require('child_process');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _fs = require('../../util/fs');

var _fs2 = _interopRequireDefault(_fs);

var _state = require('../../navy/state');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mkdirp = _bluebird2.default.promisify(require('mkdirp'));

var npmContext = _path2.default.join((0, _state.pathToNavyRoot)(), 'npm');
var nodeModulesPath = _path2.default.join(npmContext, 'node_modules');

function createNpmConfigProvider(navy) {
  return {
    getNavyPath: function getNavyPath() {
      var _this = this;

      return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var envState, navyPath;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return navy.getState();

              case 2:
                envState = _context2.sent;


                (0, _invariant2.default)(!!envState, 'STATE_NONEXISTANT: State doesn\'t exist for navy %s', navy.name);
                (0, _invariant2.default)(!!envState.npmPackage, 'NPM_PROVIDER_REQUIRES_PACKAGE: NPM config provider requires an NPM package for %s', navy.name);

                _context2.next = 7;
                return (0, _util.pathToModule)(nodeModulesPath, envState.npmPackage);

              case 7:
                navyPath = _context2.sent;


                _fs2.default.accessSync(navyPath); // see if path exists

                return _context2.abrupt('return', navyPath);

              case 10:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, _this);
      }))();
    },
    getNavyFilePath: function getNavyFilePath() {
      var _this2 = this;

      return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.t0 = _path2.default;
                _context3.next = 3;
                return _this2.getNavyPath();

              case 3:
                _context3.t1 = _context3.sent;
                return _context3.abrupt('return', _context3.t0.join.call(_context3.t0, _context3.t1, 'Navyfile.js'));

              case 5:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, _this2);
      }))();
    },
    refreshConfig: function refreshConfig() {
      var _this3 = this;

      return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        var envState;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return navy.getState();

              case 2:
                envState = _context4.sent;


                (0, _invariant2.default)(!!envState, 'STATE_NONEXISTANT: State doesn\'t exist for navy %s', navy.name);
                (0, _invariant2.default)(!!envState.npmPackage, 'NPM_PROVIDER_REQUIRES_PACKAGE: NPM config provider requires an NPM package for %s', navy.name);

                _context4.next = 7;
                return tryAndInstall(envState.npmPackage);

              case 7:
                return _context4.abrupt('return', true);

              case 8:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, _this3);
      }))();
    },
    getLocationDisplayName: function getLocationDisplayName() {
      var _this4 = this;

      return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        var envState;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return navy.getState();

              case 2:
                envState = _context5.sent;


                (0, _invariant2.default)(!!envState, 'STATE_NONEXISTANT: State doesn\'t exist for navy %s', navy.name);

                return _context5.abrupt('return', envState.npmPackage);

              case 5:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, _this4);
      }))();
    },
    isDangling: function isDangling() {
      var _this5 = this;

      return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
        var envState;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return navy.getState();

              case 2:
                envState = _context6.sent;
                return _context6.abrupt('return', !envState || !envState.npmPackage);

              case 4:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, _this5);
      }))();
    }
  };
}

createNpmConfigProvider.importCliOptions = [['--npm-package [package]', 'set the NPM package to use for docker compose config']];

createNpmConfigProvider.getImportOptionsForCLI = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(opts) {
    return _regenerator2.default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            if (!opts.npmPackage) {
              _context7.next = 4;
              break;
            }

            _context7.next = 3;
            return tryAndInstall(opts.npmPackage);

          case 3:
            return _context7.abrupt('return', {
              configProvider: 'npm',
              npmPackage: opts.npmPackage
            });

          case 4:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, undefined);
  }));

  return function (_x2) {
    return _ref2.apply(this, arguments);
  };
}();
module.exports = exports.default;