'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setConfig = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var setConfig = exports.setConfig = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(config) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (config == null) config = DEFAULT_CONFIG;

            _context.next = 3;
            return mkdirp(_path2.default.dirname(getConfigPath()));

          case 3:
            _context.next = 5;
            return _fs2.default.writeFileAsync(getConfigPath(), (0, _stringify2.default)(config, null, 2));

          case 5:

            // trash cached config
            _config = null;

          case 6:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function setConfig(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.getConfigPath = getConfigPath;
exports.getConfig = getConfig;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _fs = require('./util/fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_ENVIRONMENT_NAME = 'dev';

var DEFAULT_CONFIG = {
  defaultNavy: DEFAULT_ENVIRONMENT_NAME,
  externalIP: null
};

var mkdirp = _bluebird2.default.promisify(require('mkdirp'));

var _config = null;

function getConfigPath() {
  var home = process.env.HOME;

  (0, _invariant2.default)(home, 'NO_HOME_DIRECTORY: No home directory available');

  return _path2.default.join(home, '.navy', 'config.json');
}

function getConfig() {
  if (_config) {
    return _config;
  }

  try {
    var file = _fs2.default.readFileSync(getConfigPath(), 'utf8');
    _config = JSON.parse(file);

    return _config;
  } catch (ex) {
    return DEFAULT_CONFIG;
  }
}