'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reconfigureHTTPProxy = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var updateComposeConfig = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(navies) {
    var networks, networksConfig, config;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _dockerClient2.default.listNetworks().filter(function (net) {
              return net.Name.indexOf('_') !== -1;
            }) // is docker-compose network?
            .filter(function (net) {
              var _iteratorNormalCompletion = true;
              var _didIteratorError = false;
              var _iteratorError = undefined;

              try {
                for (var _iterator = (0, _getIterator3.default)(navies), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  var navy = _step.value;

                  if (net.Name.indexOf(navy + '_') === 0) {
                    return true;
                  }
                }
              } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion && _iterator.return) {
                    _iterator.return();
                  }
                } finally {
                  if (_didIteratorError) {
                    throw _iteratorError;
                  }
                }
              }

              return false;
            });

          case 2:
            networks = _context.sent;
            networksConfig = {};


            networks.forEach(function (net) {
              return networksConfig[net.Name] = {
                external: true
              };
            });

            config = {
              version: '2',

              services: {
                'nginx-proxy': {
                  image: 'navycloud/navy-proxy',
                  ports: ['80:80'],
                  networks: networks.map(function (net) {
                    return net.Name;
                  }),
                  volumes: ['/var/run/docker.sock:/tmp/docker.sock:ro'],
                  restart: 'always'
                }
              },

              networks: networksConfig
            };
            _context.next = 8;
            return _fs2.default.writeFileAsync(_path2.default.join(_os2.default.tmpdir(), 'navyinternaldockercompose.yml'), _jsYaml2.default.dump(config));

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function updateComposeConfig(_x) {
    return _ref.apply(this, arguments);
  };
}();

var reconfigureHTTPProxy = exports.reconfigureHTTPProxy = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (opts.navies) {
              _context2.next = 4;
              break;
            }

            _context2.next = 3;
            return (0, _navy.getLaunchedNavyNames)();

          case 3:
            opts.navies = _context2.sent;

          case 4:
            _context2.next = 6;
            return updateComposeConfig(opts.navies);

          case 6:

            (0, _driverLogging.log)('Configuring HTTP proxy...');
            _context2.next = 9;
            return (0, _execAsync.execAsync)('docker-compose', ['-f', _path2.default.join(_os2.default.tmpdir(), 'navyinternaldockercompose.yml'), '-p', 'navyinternal', 'up', '-d']);

          case 9:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function reconfigureHTTPProxy() {
    return _ref2.apply(this, arguments);
  };
}();

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _jsYaml = require('js-yaml');

var _jsYaml2 = _interopRequireDefault(_jsYaml);

var _dockerClient = require('./util/docker-client');

var _dockerClient2 = _interopRequireDefault(_dockerClient);

var _fs = require('./util/fs');

var _fs2 = _interopRequireDefault(_fs);

var _execAsync = require('./util/exec-async');

var _driverLogging = require('./driver-logging');

var _navy = require('./navy');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }