'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _lodash = require('lodash');

var _serviceHost = require('../util/service-host');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getServiceHTTPProxyConfig = function getServiceHTTPProxyConfig(serviceName, navyFile) {
  if (navyFile && navyFile.httpProxy && navyFile.httpProxy[serviceName]) {
    return navyFile.httpProxy[serviceName];
  }

  return null;
};

var serviceHasPort80 = function serviceHasPort80(service) {
  return service.ports && (0, _lodash.find)(service.ports, function (port) {
    return (
      // Should handle "80" (short syntax), "80:80" (long syntax), and "80/tcp" (including protocol) formats.
      port.toString() === '80' || port.toString().startsWith('80:') || port.toString().startsWith('80/')
    );
  });
};

exports.default = function (navy) {
  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(config, state) {
      var navyFile, services, externalIP;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return navy.getNavyFile();

            case 2:
              navyFile = _context2.sent;
              services = {};
              _context2.next = 6;
              return navy.externalIP();

            case 6:
              externalIP = _context2.sent;
              _context2.next = 9;
              return _promise2.default.all((0, _keys2.default)(config.services).map(function () {
                var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(serviceName) {
                  var service, proxyConfig;
                  return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          service = config.services[serviceName];
                          proxyConfig = getServiceHTTPProxyConfig(serviceName, navyFile);

                          // proxy port 80 even without config

                          if (!proxyConfig && serviceHasPort80(service)) {
                            proxyConfig = { port: 80 };
                          }

                          if (!proxyConfig) {
                            _context.next = 17;
                            break;
                          }

                          _context.t0 = _extends3.default;
                          _context.t1 = {};
                          _context.t2 = service;
                          _context.t3 = _extends3.default;
                          _context.next = 10;
                          return (0, _serviceHost.createHostForService)(serviceName, navy.normalisedName, externalIP);

                        case 10:
                          _context.t4 = _context.sent;
                          _context.t5 = proxyConfig.port;
                          _context.t6 = {
                            'VIRTUAL_HOST': _context.t4,
                            'VIRTUAL_PORT': _context.t5
                          };
                          _context.t7 = service.environment;
                          _context.t8 = (0, _context.t3)(_context.t6, _context.t7);
                          _context.t9 = {
                            environment: _context.t8
                          };
                          return _context.abrupt('return', services[serviceName] = (0, _context.t0)(_context.t1, _context.t2, _context.t9));

                        case 17:
                          return _context.abrupt('return', services[serviceName] = service);

                        case 18:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, undefined);
                }));

                return function (_x3) {
                  return _ref2.apply(this, arguments);
                };
              }()));

            case 9:
              return _context2.abrupt('return', (0, _extends3.default)({}, config, {
                services: services
              }));

            case 10:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

module.exports = exports.default;