'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.middlewareHelpers = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var middlewareHelpers = exports.middlewareHelpers = {
  rewriteServices: function rewriteServices(config, serviceMapperFn) {
    return (0, _extends3.default)({}, config, {
      services: (0, _lodash.mapValues)(config.services || {}, serviceMapperFn)
    });
  },
  rewriteServicesWithState: function rewriteServicesWithState(config, state, serviceMapperFn) {
    var normalisedState = state || { services: {} };

    function mapperFn(service, serviceName) {
      return serviceMapperFn(service, serviceName, normalisedState.services[serviceName]);
    }

    return (0, _extends3.default)({}, config, {
      services: (0, _lodash.mapValues)(config.services || {}, mapperFn)
    });
  },
  addVolumes: function addVolumes(service, volumes) {
    var normalisedVolumes = service.volumes || [];

    return [].concat((0, _toConsumableArray3.default)(normalisedVolumes), (0, _toConsumableArray3.default)(volumes));
  }
};