'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getPortConfig(serviceName, state) {
  return state.services[serviceName] ? state.services[serviceName]._ports || {} : {};
}

exports.default = function (config, state) {
  return (0, _extends3.default)({}, config, {
    services: (0, _lodash.mapValues)(config.services, function (service, serviceName) {
      var portConfig = getPortConfig(serviceName, state);
      var hasPortConfig = !!portConfig;
      var internalPorts = (0, _keys2.default)(portConfig).filter(function (internal) {
        return !!portConfig[internal];
      });

      var inheritedPorts = service.ports ? service.ports.filter(function (port) {
        return internalPorts.indexOf(port) === -1;
      }) : [];

      return (0, _extends3.default)({}, service, {
        ports: hasPortConfig ? [].concat((0, _toConsumableArray3.default)(inheritedPorts), (0, _toConsumableArray3.default)(internalPorts.map(function (internal) {
          return portConfig[internal] + ':' + internal;
        }))) : service.ports
      });
    })
  });
};

module.exports = exports.default;