'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (config, state) {
  var newConfig = config;

  (0, _keys2.default)(state.services || {}).forEach(function (serviceName) {
    var serviceConfig = newConfig.services[serviceName];
    var serviceState = state.services[serviceName];

    if (serviceState._tag && serviceConfig) {
      var image = serviceConfig.image;

      // strip existing tag off if it exists
      if (image.indexOf(':') !== -1) {
        image = image.substring(0, image.indexOf(':'));
      }

      // add new tag
      image += ':' + serviceState._tag;

      serviceConfig.image = image;
    }
  });

  return newConfig;
};

module.exports = exports.default;