'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getLaunchedNavyNames = exports.getLaunchedNavies = exports.Navy = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends8 = require('babel-runtime/helpers/extends');

var _extends9 = _interopRequireDefault(_extends8);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _maxSafeInteger = require('babel-runtime/core-js/number/max-safe-integer');

var _maxSafeInteger2 = _interopRequireDefault(_maxSafeInteger);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

/**
 * Returns an array of `Navy` instances which are currently imported and launched.
 * @public
 */
var getLaunchedNavies = exports.getLaunchedNavies = function () {
  var _ref35 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee35() {
    var navyNames;
    return _regenerator2.default.wrap(function _callee35$(_context35) {
      while (1) {
        switch (_context35.prev = _context35.next) {
          case 0:
            _context35.prev = 0;
            _context35.next = 3;
            return _fs2.default.readdirAsync((0, _state.pathToNavys)());

          case 3:
            navyNames = _context35.sent;
            return _context35.abrupt('return', navyNames.filter(function (node) {
              return _fs2.default.lstatSync((0, _state.pathToNavy)(node)).isDirectory();
            }).map(function (name) {
              return getNavy(name);
            }));

          case 7:
            _context35.prev = 7;
            _context35.t0 = _context35['catch'](0);
            return _context35.abrupt('return', []);

          case 10:
          case 'end':
            return _context35.stop();
        }
      }
    }, _callee35, this, [[0, 7]]);
  }));

  return function getLaunchedNavies() {
    return _ref35.apply(this, arguments);
  };
}();

/**
 * Returns an array of names of Navies which are currently imported and launched.
 * @public
 */


var getLaunchedNavyNames = exports.getLaunchedNavyNames = function () {
  var _ref36 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee36() {
    return _regenerator2.default.wrap(function _callee36$(_context36) {
      while (1) {
        switch (_context36.prev = _context36.next) {
          case 0:
            _context36.prev = 0;
            _context36.next = 3;
            return _fs2.default.readdirAsync((0, _state.pathToNavys)());

          case 3:
            return _context36.abrupt('return', _context36.sent);

          case 6:
            _context36.prev = 6;
            _context36.t0 = _context36['catch'](0);
            return _context36.abrupt('return', []);

          case 9:
          case 'end':
            return _context36.stop();
        }
      }
    }, _callee36, this, [[0, 6]]);
  }));

  return function getLaunchedNavyNames() {
    return _ref36.apply(this, arguments);
  };
}();

exports.getNavy = getNavy;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _eventemitter = require('eventemitter2');

var _promiseRetry = require('promise-retry');

var _promiseRetry2 = _interopRequireDefault(_promiseRetry);

var _fs = require('../util/fs');

var _fs2 = _interopRequireDefault(_fs);

var _driver = require('../driver');

var _configProvider = require('../config-provider');

var _util = require('./util');

var _state = require('./state');

var _config = require('../config');

var _errors = require('../errors');

var _pluginInterface = require('./plugin-interface');

var _middleware = require('./middleware');

var _httpProxy = require('../http-proxy');

var _externalIp = require('../util/external-ip');

var _serviceHost = require('../util/service-host');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A Navy instance
 * @public
 */
var Navy = exports.Navy = function (_EventEmitter) {
  (0, _inherits3.default)(Navy, _EventEmitter);

  /**
   * The normalised name of the current Navy (name without whitespaces).
   * @public
   */
  function Navy(name) {
    (0, _classCallCheck3.default)(this, Navy);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Navy.__proto__ || (0, _getPrototypeOf2.default)(Navy)).call(this, {
      maxListeners: _maxSafeInteger2.default,
      wildcard: true,
      delimiter: '.'
    }));

    _this.name = name;
    _this.normalisedName = (0, _util.normaliseNavyName)(name);

    _this._pluginsLoaded = false;
    _this._registeredCommands = {};
    _this._registeredMiddleware = [];
    return _this;
  }

  /**
   * The name of the current Navy.
   * @public
   */


  (0, _createClass3.default)(Navy, [{
    key: 'ensurePluginsLoaded',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var navyFile;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!this._pluginsLoaded) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt('return');

              case 2:
                _context.next = 4;
                return this.getNavyFile();

              case 4:
                navyFile = _context.sent;

                if (navyFile) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt('return');

              case 7:
                _context.next = 9;
                return (0, _pluginInterface.loadPlugins)(this, navyFile);

              case 9:

                this._pluginsLoaded = true;

              case 10:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function ensurePluginsLoaded() {
        return _ref.apply(this, arguments);
      }

      return ensurePluginsLoaded;
    }()

    /**
     * Returns the current State for this Navy.
     * @public
     */

  }, {
    key: 'getState',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return (0, _state.getState)(this.normalisedName);

              case 2:
                return _context2.abrupt('return', _context2.sent);

              case 3:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getState() {
        return _ref2.apply(this, arguments);
      }

      return getState;
    }()

    /**
     * Returns an instance of the driver in use by this navy.
     * Returns null if the navy hasn't been launched yet.
     */

  }, {
    key: 'getDriver',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var envState, createDriver;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.getState();

              case 2:
                envState = _context3.sent;

                if (!(!envState || !envState.driver)) {
                  _context3.next = 5;
                  break;
                }

                return _context3.abrupt('return', null);

              case 5:
                createDriver = (0, _driver.resolveDriverFromName)(envState.driver);

                if (createDriver) {
                  _context3.next = 8;
                  break;
                }

                return _context3.abrupt('return', null);

              case 8:
                return _context3.abrupt('return', createDriver(this));

              case 9:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function getDriver() {
        return _ref3.apply(this, arguments);
      }

      return getDriver;
    }()

    /**
     * Same as getDriver but will throw an error if the driver cannot be determined.
     */

  }, {
    key: 'safeGetDriver',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        var driver;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.getDriver();

              case 2:
                driver = _context4.sent;
                _context4.next = 5;
                return this.isInitialised();

              case 5:
                if (_context4.sent) {
                  _context4.next = 7;
                  break;
                }

                throw new _errors.NavyNotInitialisedError(this.name);

              case 7:

                (0, _invariant2.default)(driver, 'NO_DRIVER: Couldn\'t determine driver for navy %s', this.name);

                return _context4.abrupt('return', driver);

              case 9:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function safeGetDriver() {
        return _ref4.apply(this, arguments);
      }

      return safeGetDriver;
    }()
  }, {
    key: 'getConfigProvider',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        var envState, createConfigProvider;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.getState();

              case 2:
                envState = _context5.sent;

                if (!(!envState || !envState.configProvider)) {
                  _context5.next = 5;
                  break;
                }

                return _context5.abrupt('return', null);

              case 5:
                createConfigProvider = (0, _configProvider.resolveConfigProviderFromName)(envState.configProvider);

                if (createConfigProvider) {
                  _context5.next = 8;
                  break;
                }

                return _context5.abrupt('return', null);

              case 8:
                return _context5.abrupt('return', createConfigProvider(this));

              case 9:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function getConfigProvider() {
        return _ref5.apply(this, arguments);
      }

      return getConfigProvider;
    }()
  }, {
    key: 'getNavyFile',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
        var configProvider, navyFilePath;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.isInitialised();

              case 2:
                if (_context6.sent) {
                  _context6.next = 4;
                  break;
                }

                throw new _errors.NavyNotInitialisedError(this.name);

              case 4:
                _context6.next = 6;
                return this.getConfigProvider();

              case 6:
                configProvider = _context6.sent;


                (0, _invariant2.default)(configProvider, 'NO_CONFIG_PROVIDER: Couldn\'t determine config provider for navy %s', this.name);

                _context6.next = 10;
                return configProvider.getNavyFilePath();

              case 10:
                navyFilePath = _context6.sent;
                _context6.prev = 11;
                return _context6.abrupt('return', require(navyFilePath));

              case 15:
                _context6.prev = 15;
                _context6.t0 = _context6['catch'](11);
                return _context6.abrupt('return', null);

              case 18:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this, [[11, 15]]);
      }));

      function getNavyFile() {
        return _ref6.apply(this, arguments);
      }

      return getNavyFile;
    }()

    /**
     * Saves a new State for this Navy.
     * @public
     */

  }, {
    key: 'saveState',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(state) {
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return (0, _state.saveState)(this.normalisedName, state);

              case 2:
                _context7.next = 4;
                return (0, _middleware.middlewareRunner)(this, state);

              case 4:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function saveState(_x) {
        return _ref7.apply(this, arguments);
      }

      return saveState;
    }()

    /**
     * Registers a custom CLI command with the given name and callback function.
     * Any command registered can be run using `navy run [name]`.
     * @public
     */

  }, {
    key: 'registerCommand',
    value: function registerCommand(name, action) {
      this._registeredCommands[name] = action;
    }

    /**
     * Registers a middleware reducer function. See [Writing Plugins](docs/writing-plugins.md).
     * @public
     */

  }, {
    key: 'registerMiddleware',
    value: function registerMiddleware(middlewareFn) {
      this._registeredMiddleware.push(middlewareFn);
    }
  }, {
    key: 'invokeCommand',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(name, args) {
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                if (this._registeredCommands[name]) {
                  _context8.next = 2;
                  break;
                }

                throw new _errors.NavyError('Unknown command "' + name + '"');

              case 2:
                _context8.next = 4;
                return this._registeredCommands[name](args);

              case 4:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function invokeCommand(_x2, _x3) {
        return _ref8.apply(this, arguments);
      }

      return invokeCommand;
    }()

    /**
     * Returns whether this Navy is initialised and ready to launch services.
     * @public
     */

  }, {
    key: 'isInitialised',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9() {
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this.getState();

              case 2:
                _context9.t0 = _context9.sent;
                return _context9.abrupt('return', _context9.t0 != null);

              case 4:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function isInitialised() {
        return _ref9.apply(this, arguments);
      }

      return isInitialised;
    }()

    /**
     * Initialises this Navy with the given State.
     * @public
     */

  }, {
    key: 'initialise',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(opts) {
        var state;
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                state = (0, _extends9.default)({
                  services: {}
                }, opts, {
                  driver: 'docker-compose'
                });
                _context10.next = 3;
                return (0, _state.saveState)(this.normalisedName, state);

              case 3:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function initialise(_x4) {
        return _ref10.apply(this, arguments);
      }

      return initialise;
    }()

    /**
     * Deletes the state for this Navy. It won't be possible to interact with this Navy after calling this function
     * unless you re-initialise it.
     * @public
     */

  }, {
    key: 'delete',
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11() {
        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return (0, _state.deleteState)(this.normalisedName);

              case 2:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function _delete() {
        return _ref11.apply(this, arguments);
      }

      return _delete;
    }()

    /**
     * Launches the given services for this Navy.
     * @public
     */

  }, {
    key: 'launch',
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee12(serviceNames, opts) {
        var availableServices, validServiceNames, allServiceNamesInvalid, state;
        return _regenerator2.default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                if (serviceNames) {
                  _context12.next = 4;
                  break;
                }

                _context12.next = 3;
                return this.getLaunchedServiceNames();

              case 3:
                serviceNames = _context12.sent;

              case 4:
                _context12.next = 6;
                return this.safeGetDriver();

              case 6:
                _context12.next = 8;
                return _context12.sent.getAvailableServiceNames();

              case 8:
                availableServices = _context12.sent;
                validServiceNames = serviceNames.filter(function (serviceName) {
                  if (availableServices.indexOf(serviceName) !== -1) {
                    return true;
                  }
                  console.log('Unknown service name: ' + serviceName);
                  return false;
                });
                allServiceNamesInvalid = serviceNames.length > 0 && validServiceNames.length === 0;

                if (!allServiceNamesInvalid) {
                  _context12.next = 13;
                  break;
                }

                return _context12.abrupt('return');

              case 13:
                _context12.next = 15;
                return this.getState();

              case 15:
                state = _context12.sent;

                if (!state) {
                  _context12.next = 19;
                  break;
                }

                _context12.next = 19;
                return (0, _middleware.middlewareRunner)(this, state);

              case 19:
                _context12.next = 21;
                return this.safeGetDriver();

              case 21:
                _context12.t0 = validServiceNames;
                _context12.t1 = opts;
                _context12.next = 25;
                return _context12.sent.launch(_context12.t0, _context12.t1);

              case 25:
                _context12.next = 27;
                return (0, _httpProxy.reconfigureHTTPProxy)();

              case 27:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function launch(_x5, _x6) {
        return _ref12.apply(this, arguments);
      }

      return launch;
    }()

    /**
     * @deprecated
     */

  }, {
    key: 'relaunch',
    value: function () {
      var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee13(opts) {
        return _regenerator2.default.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _context13.next = 2;
                return this.reconfigure(opts);

              case 2:
                return _context13.abrupt('return', _context13.sent);

              case 3:
              case 'end':
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function relaunch(_x7) {
        return _ref13.apply(this, arguments);
      }

      return relaunch;
    }()

    /**
     * Relaunches (reconfigures) all of the services running in this Navy.
     * This will pick up any changes to the compose configuration.
     * @public
     */

  }, {
    key: 'reconfigure',
    value: function () {
      var _ref14 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee14(opts) {
        var services;
        return _regenerator2.default.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                _context14.next = 2;
                return this.getLaunchedServiceNames();

              case 2:
                services = _context14.sent;

                if (!(services.length === 0)) {
                  _context14.next = 5;
                  break;
                }

                return _context14.abrupt('return');

              case 5:
                _context14.next = 7;
                return this.launch(undefined, opts);

              case 7:
              case 'end':
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function reconfigure(_x8) {
        return _ref14.apply(this, arguments);
      }

      return reconfigure;
    }()

    /**
     * Destroys all of the services in this Navy and deletes the state.
     * @public
     */

  }, {
    key: 'destroy',
    value: function () {
      var _ref15 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee15() {
        var _this2 = this;

        return _regenerator2.default.wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                _context15.next = 2;
                return this.isInitialised();

              case 2:
                if (_context15.sent) {
                  _context15.next = 4;
                  break;
                }

                throw new _errors.NavyNotInitialisedError(this.name);

              case 4:
                _context15.t0 = _httpProxy.reconfigureHTTPProxy;
                _context15.next = 7;
                return getLaunchedNavyNames();

              case 7:
                _context15.t1 = function (navy) {
                  return navy !== _this2.normalisedName;
                };

                _context15.t2 = _context15.sent.filter(_context15.t1);
                _context15.t3 = {
                  navies: _context15.t2
                };
                _context15.next = 12;
                return (0, _context15.t0)(_context15.t3);

              case 12:
                _context15.prev = 12;
                _context15.next = 15;
                return this.safeGetDriver();

              case 15:
                _context15.next = 17;
                return _context15.sent.destroy();

              case 17:
                _context15.next = 21;
                break;

              case 19:
                _context15.prev = 19;
                _context15.t4 = _context15['catch'](12);

              case 21:
                _context15.next = 23;
                return this.delete();

              case 23:
              case 'end':
                return _context15.stop();
            }
          }
        }, _callee15, this, [[12, 19]]);
      }));

      function destroy() {
        return _ref15.apply(this, arguments);
      }

      return destroy;
    }()

    /**
     * Returns a list of launched services for this Navy.
     * @public
     */

  }, {
    key: 'ps',
    value: function () {
      var _ref16 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee16() {
        return _regenerator2.default.wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                _context16.next = 2;
                return this.safeGetDriver();

              case 2:
                _context16.next = 4;
                return _context16.sent.ps();

              case 4:
                return _context16.abrupt('return', _context16.sent);

              case 5:
              case 'end':
                return _context16.stop();
            }
          }
        }, _callee16, this);
      }));

      function ps() {
        return _ref16.apply(this, arguments);
      }

      return ps;
    }()

    /**
     * Starts the given services.
     * @public
     */

  }, {
    key: 'start',
    value: function () {
      var _ref17 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee17(services) {
        return _regenerator2.default.wrap(function _callee17$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                if (services) {
                  _context17.next = 4;
                  break;
                }

                _context17.next = 3;
                return this.getLaunchedServiceNames();

              case 3:
                services = _context17.sent;

              case 4:
                _context17.next = 6;
                return (0, _httpProxy.reconfigureHTTPProxy)();

              case 6:
                _context17.next = 8;
                return this.safeGetDriver();

              case 8:
                _context17.t0 = services;
                _context17.next = 11;
                return _context17.sent.start(_context17.t0);

              case 11:
              case 'end':
                return _context17.stop();
            }
          }
        }, _callee17, this);
      }));

      function start(_x9) {
        return _ref17.apply(this, arguments);
      }

      return start;
    }()

    /**
     * Stops the given services.
     * @public
     */

  }, {
    key: 'stop',
    value: function () {
      var _ref18 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee18(services) {
        return _regenerator2.default.wrap(function _callee18$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                if (services) {
                  _context18.next = 4;
                  break;
                }

                _context18.next = 3;
                return this.getLaunchedServiceNames();

              case 3:
                services = _context18.sent;

              case 4:
                _context18.next = 6;
                return this.safeGetDriver();

              case 6:
                _context18.t0 = services;
                _context18.next = 9;
                return _context18.sent.stop(_context18.t0);

              case 9:
              case 'end':
                return _context18.stop();
            }
          }
        }, _callee18, this);
      }));

      function stop(_x10) {
        return _ref18.apply(this, arguments);
      }

      return stop;
    }()

    /**
     * Restarts the given services.
     * @public
     */

  }, {
    key: 'restart',
    value: function () {
      var _ref19 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee19(services) {
        return _regenerator2.default.wrap(function _callee19$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                if (services) {
                  _context19.next = 4;
                  break;
                }

                _context19.next = 3;
                return this.getLaunchedServiceNames();

              case 3:
                services = _context19.sent;

              case 4:
                _context19.next = 6;
                return this.safeGetDriver();

              case 6:
                _context19.t0 = services;
                _context19.next = 9;
                return _context19.sent.restart(_context19.t0);

              case 9:
              case 'end':
                return _context19.stop();
            }
          }
        }, _callee19, this);
      }));

      function restart(_x11) {
        return _ref19.apply(this, arguments);
      }

      return restart;
    }()

    /**
     * Forcefully stops the given services.
     * @public
     */

  }, {
    key: 'kill',
    value: function () {
      var _ref20 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee20(services) {
        return _regenerator2.default.wrap(function _callee20$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                if (services) {
                  _context20.next = 4;
                  break;
                }

                _context20.next = 3;
                return this.getLaunchedServiceNames();

              case 3:
                services = _context20.sent;

              case 4:
                _context20.next = 6;
                return this.safeGetDriver();

              case 6:
                _context20.t0 = services;
                _context20.next = 9;
                return _context20.sent.kill(_context20.t0);

              case 9:
              case 'end':
                return _context20.stop();
            }
          }
        }, _callee20, this);
      }));

      function kill(_x12) {
        return _ref20.apply(this, arguments);
      }

      return kill;
    }()

    /**
     * Removes the given services. Requires the services to be stopped first.
     * @public
     */

  }, {
    key: 'rm',
    value: function () {
      var _ref21 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee21(services) {
        return _regenerator2.default.wrap(function _callee21$(_context21) {
          while (1) {
            switch (_context21.prev = _context21.next) {
              case 0:
                if (services) {
                  _context21.next = 4;
                  break;
                }

                _context21.next = 3;
                return this.getLaunchedServiceNames();

              case 3:
                services = _context21.sent;

              case 4:
                _context21.next = 6;
                return this.safeGetDriver();

              case 6:
                _context21.t0 = services;
                _context21.next = 9;
                return _context21.sent.rm(_context21.t0);

              case 9:
              case 'end':
                return _context21.stop();
            }
          }
        }, _callee21, this);
      }));

      function rm(_x13) {
        return _ref21.apply(this, arguments);
      }

      return rm;
    }()

    /**
     * Makes sure the images for the given services are up to date, and restarts any running
     * services with new images.
     * @public
     */

  }, {
    key: 'update',
    value: function () {
      var _ref22 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee22(services) {
        return _regenerator2.default.wrap(function _callee22$(_context22) {
          while (1) {
            switch (_context22.prev = _context22.next) {
              case 0:
                if (services) {
                  _context22.next = 4;
                  break;
                }

                _context22.next = 3;
                return this.getAvailableServiceNames();

              case 3:
                services = _context22.sent;

              case 4:
                _context22.next = 6;
                return this.safeGetDriver();

              case 6:
                _context22.t0 = services;
                _context22.next = 9;
                return _context22.sent.update(_context22.t0);

              case 9:
              case 'end':
                return _context22.stop();
            }
          }
        }, _callee22, this);
      }));

      function update(_x14) {
        return _ref22.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: 'spawnLogStream',
    value: function () {
      var _ref23 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee23(services) {
        return _regenerator2.default.wrap(function _callee23$(_context23) {
          while (1) {
            switch (_context23.prev = _context23.next) {
              case 0:
                if (services) {
                  _context23.next = 4;
                  break;
                }

                _context23.next = 3;
                return this.getLaunchedServiceNames();

              case 3:
                services = _context23.sent;

              case 4:
                _context23.next = 6;
                return this.safeGetDriver();

              case 6:
                _context23.t0 = services;
                _context23.next = 9;
                return _context23.sent.spawnLogStream(_context23.t0);

              case 9:
              case 'end':
                return _context23.stop();
            }
          }
        }, _callee23, this);
      }));

      function spawnLogStream(_x15) {
        return _ref23.apply(this, arguments);
      }

      return spawnLogStream;
    }()

    /**
     * Locks down the given service to the given docker image tag.
     * @public
     */

  }, {
    key: 'useTag',
    value: function () {
      var _ref24 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee24(service, tag) {
        var state;
        return _regenerator2.default.wrap(function _callee24$(_context24) {
          while (1) {
            switch (_context24.prev = _context24.next) {
              case 0:
                _context24.next = 2;
                return this.getState();

              case 2:
                _context24.t0 = _context24.sent;

                if (_context24.t0) {
                  _context24.next = 5;
                  break;
                }

                _context24.t0 = {};

              case 5:
                state = _context24.t0;
                _context24.next = 8;
                return this.saveState((0, _extends9.default)({}, state, {
                  services: (0, _extends9.default)({}, state.services, (0, _defineProperty3.default)({}, service, (0, _extends9.default)({}, (state.services || {})[service], {
                    _tag: tag
                  })))
                }));

              case 8:
                _context24.next = 10;
                return this.kill([service]);

              case 10:
                _context24.next = 12;
                return this.update([service]);

              case 12:
              case 'end':
                return _context24.stop();
            }
          }
        }, _callee24, this);
      }));

      function useTag(_x16, _x17) {
        return _ref24.apply(this, arguments);
      }

      return useTag;
    }()

    /**
     * Resets the version of the given service if `useTag` was used.
     * @public
     */

  }, {
    key: 'resetTag',
    value: function () {
      var _ref25 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee25(service) {
        var state;
        return _regenerator2.default.wrap(function _callee25$(_context25) {
          while (1) {
            switch (_context25.prev = _context25.next) {
              case 0:
                _context25.next = 2;
                return this.getState();

              case 2:
                _context25.t0 = _context25.sent;

                if (_context25.t0) {
                  _context25.next = 5;
                  break;
                }

                _context25.t0 = {};

              case 5:
                state = _context25.t0;
                _context25.next = 8;
                return this.saveState((0, _extends9.default)({}, state, {
                  services: (0, _extends9.default)({}, state.services, (0, _defineProperty3.default)({}, service, (0, _extends9.default)({}, (state.services || {})[service], {
                    _tag: undefined
                  })))
                }));

              case 8:
                _context25.next = 10;
                return this.kill([service]);

              case 10:
                _context25.next = 12;
                return this.launch([service], { noDeps: true });

              case 12:
              case 'end':
                return _context25.stop();
            }
          }
        }, _callee25, this);
      }));

      function resetTag(_x18) {
        return _ref25.apply(this, arguments);
      }

      return resetTag;
    }()
  }, {
    key: 'usePort',
    value: function () {
      var _ref26 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee26(service, privatePort, externalPort) {
        var state;
        return _regenerator2.default.wrap(function _callee26$(_context26) {
          while (1) {
            switch (_context26.prev = _context26.next) {
              case 0:
                _context26.next = 2;
                return this.getState();

              case 2:
                _context26.t0 = _context26.sent;

                if (_context26.t0) {
                  _context26.next = 5;
                  break;
                }

                _context26.t0 = {};

              case 5:
                state = _context26.t0;
                _context26.next = 8;
                return this.saveState((0, _extends9.default)({}, state, {
                  services: (0, _extends9.default)({}, state.services, (0, _defineProperty3.default)({}, service, (0, _extends9.default)({}, (state.services || {})[service], {
                    _ports: (0, _extends9.default)({}, ((state.services || {})[service] || {})._ports, (0, _defineProperty3.default)({}, privatePort, externalPort))
                  })))
                }));

              case 8:
                _context26.next = 10;
                return this.kill([service]);

              case 10:
                _context26.next = 12;
                return this.launch([service], { noDeps: true });

              case 12:
              case 'end':
                return _context26.stop();
            }
          }
        }, _callee26, this);
      }));

      function usePort(_x19, _x20, _x21) {
        return _ref26.apply(this, arguments);
      }

      return usePort;
    }()
  }, {
    key: 'resetPort',
    value: function () {
      var _ref27 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee27(service, privatePort) {
        var state;
        return _regenerator2.default.wrap(function _callee27$(_context27) {
          while (1) {
            switch (_context27.prev = _context27.next) {
              case 0:
                _context27.next = 2;
                return this.getState();

              case 2:
                _context27.t0 = _context27.sent;

                if (_context27.t0) {
                  _context27.next = 5;
                  break;
                }

                _context27.t0 = {};

              case 5:
                state = _context27.t0;
                _context27.next = 8;
                return this.saveState((0, _extends9.default)({}, state, {
                  services: (0, _extends9.default)({}, state.services, (0, _defineProperty3.default)({}, service, (0, _extends9.default)({}, (state.services || {})[service], {
                    _ports: (0, _extends9.default)({}, ((state.services || {})[service] || {})._ports, (0, _defineProperty3.default)({}, privatePort, undefined))
                  })))
                }));

              case 8:
                _context27.next = 10;
                return this.kill([service]);

              case 10:
                _context27.next = 12;
                return this.launch([service], { noDeps: true });

              case 12:
              case 'end':
                return _context27.stop();
            }
          }
        }, _callee27, this);
      }));

      function resetPort(_x22, _x23) {
        return _ref27.apply(this, arguments);
      }

      return resetPort;
    }()

    /**
     * Waits for the given services to be healthy. Resolves when all services are healthy.
     * @public
     */

  }, {
    key: 'waitForHealthy',
    value: function () {
      var _ref28 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee29(services, progressCallback) {
        var _this3 = this;

        var retryConfig = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : { factor: 1.1, retries: 30, minTimeout: 200 };
        return _regenerator2.default.wrap(function _callee29$(_context29) {
          while (1) {
            switch (_context29.prev = _context29.next) {
              case 0:
                if (!(services == null)) {
                  _context29.next = 6;
                  break;
                }

                _context29.next = 3;
                return this.ps();

              case 3:
                _context29.t0 = function (service) {
                  return service && service.raw && service.raw.State.Health;
                };

                _context29.t1 = function (service) {
                  return service.name;
                };

                services = _context29.sent.filter(_context29.t0).map(_context29.t1);

              case 6:
                _context29.prev = 6;
                _context29.next = 9;
                return (0, _promiseRetry2.default)(retryConfig, function () {
                  var _ref29 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee28(retry) {
                    var ps, specifiedServices, servicesWithoutHealthInfo, serviceHealth, unhealthy;
                    return _regenerator2.default.wrap(function _callee28$(_context28) {
                      while (1) {
                        switch (_context28.prev = _context28.next) {
                          case 0:
                            _context28.next = 2;
                            return _this3.ps();

                          case 2:
                            ps = _context28.sent;
                            specifiedServices = ps.filter(function (service) {
                              return services && services.indexOf(service.name) !== -1;
                            });
                            servicesWithoutHealthInfo = specifiedServices.filter(function (service) {
                              return !service.raw || !service.raw.State.Health;
                            }).map(function (service) {
                              return service.name;
                            });

                            if (!(servicesWithoutHealthInfo.length > 0)) {
                              _context28.next = 7;
                              break;
                            }

                            throw new _errors.NavyError('The specified services don\'t have health checks: ' + servicesWithoutHealthInfo.join(', '));

                          case 7:
                            serviceHealth = specifiedServices.map(function (service) {
                              return {
                                service: service.name,
                                health: service.raw && service.raw.State.Health.Status
                              };
                            });


                            if (progressCallback) progressCallback(serviceHealth);

                            unhealthy = serviceHealth.filter(function (service) {
                              return service.health !== 'healthy';
                            });


                            if (unhealthy.length !== 0) {
                              retry('Timed out waiting for services to be healthy. Unhealthy services: ' + unhealthy.map(function (s) {
                                return s.service;
                              }).join(', '));
                            }

                          case 11:
                          case 'end':
                            return _context28.stop();
                        }
                      }
                    }, _callee28, _this3);
                  }));

                  return function (_x27) {
                    return _ref29.apply(this, arguments);
                  };
                }());

              case 9:
                _context29.next = 14;
                break;

              case 11:
                _context29.prev = 11;
                _context29.t2 = _context29['catch'](6);
                throw new _errors.NavyError(_context29.t2.message);

              case 14:
                return _context29.abrupt('return', true);

              case 15:
              case 'end':
                return _context29.stop();
            }
          }
        }, _callee29, this, [[6, 11]]);
      }));

      function waitForHealthy(_x24, _x25) {
        return _ref28.apply(this, arguments);
      }

      return waitForHealthy;
    }()

    /**
     * Returns the external IP for accessing Docker and running services.
     * @public
     */

  }, {
    key: 'externalIP',
    value: function () {
      var _ref30 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee30() {
        var config;
        return _regenerator2.default.wrap(function _callee30$(_context30) {
          while (1) {
            switch (_context30.prev = _context30.next) {
              case 0:
                _context30.next = 2;
                return (0, _config.getConfig)();

              case 2:
                config = _context30.sent;
                _context30.next = 5;
                return (0, _externalIp.getExternalIP)(config.externalIP);

              case 5:
                return _context30.abrupt('return', _context30.sent);

              case 6:
              case 'end':
                return _context30.stop();
            }
          }
        }, _callee30, this);
      }));

      function externalIP() {
        return _ref30.apply(this, arguments);
      }

      return externalIP;
    }()

    /**
     * Returns the external port for the given service and internal private port.
     * @public
     */

  }, {
    key: 'port',
    value: function () {
      var _ref31 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee31(service, privatePort) {
        var index = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
        return _regenerator2.default.wrap(function _callee31$(_context31) {
          while (1) {
            switch (_context31.prev = _context31.next) {
              case 0:
                _context31.next = 2;
                return this.safeGetDriver();

              case 2:
                _context31.t0 = service;
                _context31.t1 = privatePort;
                _context31.t2 = index;
                _context31.next = 7;
                return _context31.sent.port(_context31.t0, _context31.t1, _context31.t2);

              case 7:
                return _context31.abrupt('return', _context31.sent);

              case 8:
              case 'end':
                return _context31.stop();
            }
          }
        }, _callee31, this);
      }));

      function port(_x28, _x29) {
        return _ref31.apply(this, arguments);
      }

      return port;
    }()

    /**
     * Returns the URL for the given service which can be used to access it if it exposes
     * a HTTP server.
     * @public
     */

  }, {
    key: 'url',
    value: function () {
      var _ref32 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee32(service) {
        var ps;
        return _regenerator2.default.wrap(function _callee32$(_context32) {
          while (1) {
            switch (_context32.prev = _context32.next) {
              case 0:
                _context32.next = 2;
                return this.safeGetDriver();

              case 2:
                _context32.t0 = service;
                _context32.next = 5;
                return _context32.sent.ps(_context32.t0);

              case 5:
                ps = _context32.sent;
                _context32.t1 = (0, _serviceHost.getUrlFromService)(ps.pop());

                if (_context32.t1) {
                  _context32.next = 15;
                  break;
                }

                _context32.t2 = _serviceHost.createUrlForService;
                _context32.t3 = service;
                _context32.t4 = this.normalisedName;
                _context32.next = 13;
                return this.externalIP();

              case 13:
                _context32.t5 = _context32.sent;
                _context32.t1 = (0, _context32.t2)(_context32.t3, _context32.t4, _context32.t5);

              case 15:
                return _context32.abrupt('return', _context32.t1);

              case 16:
              case 'end':
                return _context32.stop();
            }
          }
        }, _callee32, this);
      }));

      function url(_x31) {
        return _ref32.apply(this, arguments);
      }

      return url;
    }()

    /**
     * Returns an array of the names of the launched services for this Navy.
     * @public
     */

  }, {
    key: 'getLaunchedServiceNames',
    value: function () {
      var _ref33 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee33() {
        return _regenerator2.default.wrap(function _callee33$(_context33) {
          while (1) {
            switch (_context33.prev = _context33.next) {
              case 0:
                _context33.next = 2;
                return this.safeGetDriver();

              case 2:
                _context33.next = 4;
                return _context33.sent.getLaunchedServiceNames();

              case 4:
                return _context33.abrupt('return', _context33.sent);

              case 5:
              case 'end':
                return _context33.stop();
            }
          }
        }, _callee33, this);
      }));

      function getLaunchedServiceNames() {
        return _ref33.apply(this, arguments);
      }

      return getLaunchedServiceNames;
    }()

    /**
     * Returns an array of the names of all of the possible services for this Navy.
     * @public
     */

  }, {
    key: 'getAvailableServiceNames',
    value: function () {
      var _ref34 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee34() {
        return _regenerator2.default.wrap(function _callee34$(_context34) {
          while (1) {
            switch (_context34.prev = _context34.next) {
              case 0:
                _context34.next = 2;
                return this.safeGetDriver();

              case 2:
                _context34.next = 4;
                return _context34.sent.getAvailableServiceNames();

              case 4:
                return _context34.abrupt('return', _context34.sent);

              case 5:
              case 'end':
                return _context34.stop();
            }
          }
        }, _callee34, this);
      }));

      function getAvailableServiceNames() {
        return _ref34.apply(this, arguments);
      }

      return getAvailableServiceNames;
    }()
  }]);
  return Navy;
}(_eventemitter.EventEmitter2);

/**
 * Returns a `Navy` instance from the given Navy name.
 * @public
 */


function getNavy(navyName) {
  (0, _invariant2.default)(navyName, 'NO_NAVY_PROVIDED: No Navy provided');

  return new Navy(navyName);
}