'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loadPlugins = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var loadPlugins = exports.loadPlugins = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(navy, navyFile) {
    var _this = this;

    var configProvider, basedir, pluginPaths, plugins;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return navy.getConfigProvider();

          case 2:
            configProvider = _context2.sent;

            (0, _invariant2.default)(configProvider, 'NO_CONFIG_PROVIDER: Couldn\'t determine config provider for navy %s', navy.name);

            _context2.next = 6;
            return configProvider.getNavyPath();

          case 6:
            basedir = _context2.sent;

            if (navyFile.plugins) {
              _context2.next = 9;
              break;
            }

            return _context2.abrupt('return', []);

          case 9:
            pluginPaths = void 0;
            _context2.prev = 10;
            _context2.next = 13;
            return _promise2.default.all(navyFile.plugins.map(function () {
              var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(pluginName) {
                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        return _context.abrupt('return', resolve(pluginName, { basedir: basedir }));

                      case 1:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function (_x3) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 13:
            pluginPaths = _context2.sent;
            _context2.next = 19;
            break;

          case 16:
            _context2.prev = 16;
            _context2.t0 = _context2['catch'](10);

            (0, _invariant2.default)(false, 'PLUGIN_RESOLVE_ERR: Could not resolve some of the plugins in Navyfile.js: %s', navyFile.plugins.join(', '));

          case 19:

            // $FlowIgnore: entry point to plugin has to be dynamic
            plugins = pluginPaths.map(function (pluginPath) {
              return require(pluginPath);
            });
            return _context2.abrupt('return', plugins.map(function (Plugin, index) {
              (0, _invariant2.default)(typeof Plugin === 'function', 'PLUGIN_DOESNT_EXPORT_FUNCTION: Plugin %s doesn\'t export a function as the entrypoint', navyFile.plugins[index]);

              return Plugin(navy);
            }));

          case 21:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[10, 16]]);
  }));

  return function loadPlugins(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var resolve = _bluebird2.default.promisify(require('resolve'));