'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteState = exports.saveState = exports.getState = undefined;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

/* eslint-disable no-use-before-define */
var getState = exports.getState = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(normalisedEnvName) {
    var statePath, file;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            statePath = pathToState(normalisedEnvName);
            _context.next = 4;
            return _fs2.default.readFileAsync(statePath);

          case 4:
            file = _context.sent.toString();


            debug('Got raw state for env ' + normalisedEnvName, statePath, file);

            return _context.abrupt('return', JSON.parse(file));

          case 9:
            _context.prev = 9;
            _context.t0 = _context['catch'](0);
            return _context.abrupt('return', null);

          case 12:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 9]]);
  }));

  return function getState(_x) {
    return _ref.apply(this, arguments);
  };
}();

var saveState = exports.saveState = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(normalisedEnvName, state) {
    var statePath;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            statePath = pathToState(normalisedEnvName);
            _context2.next = 3;
            return mkdirp(_path2.default.dirname(statePath));

          case 3:

            debug('Writing state for env ' + normalisedEnvName, statePath, state);

            _context2.next = 6;
            return _fs2.default.writeFileAsync(statePath, (0, _stringify2.default)(state, null, 2));

          case 6:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function saveState(_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}();

var deleteState = exports.deleteState = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(normalisedEnvName) {
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            debug('Deleting state for env ' + normalisedEnvName);

            _context3.next = 3;
            return rimraf(_path2.default.dirname(pathToState(normalisedEnvName)));

          case 3:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function deleteState(_x4) {
    return _ref3.apply(this, arguments);
  };
}();

/**
 * A "state" object of the current services, and other internal Navy state.
 * This can be used to hang "state" off services which can then be used by middleware at runtime to modify the
 * runtime configuration.
 *
 * Accessing internal properties on state (properties other than "services") is not supported and backwards
 * compatibility is not guaranteed.
 *
 * @public
 * @property {object} services An object hash of the state of each service
 */


exports.pathToNavyRoot = pathToNavyRoot;
exports.pathToNavys = pathToNavys;
exports.pathToNavy = pathToNavy;
exports.pathToState = pathToState;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _fs = require('../util/fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('navy:state');

var mkdirp = _bluebird2.default.promisify(require('mkdirp'));
var rimraf = _bluebird2.default.promisify(require('rimraf'));

function pathToNavyRoot() {
  var home = process.env.HOME;
  (0, _invariant2.default)(home, 'NO_HOME_DIRECTORY: No home directory available');

  return _path2.default.join(home, '.navy');
}

function pathToNavys() {
  return _path2.default.join(pathToNavyRoot(), 'navies');
}

function pathToNavy(normalisedEnvName) {
  return _path2.default.join(pathToNavys(), normalisedEnvName);
}

function pathToState(normalisedEnvName) {
  return _path2.default.join(pathToNavy(normalisedEnvName), 'state.json');
}