'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _chai = require('chai');

var _externalIp = require('../external-ip');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-env mocha */

describe('getExternalIP', function () {

  it('should return NAVY_EXTERNAL_IP if set', (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            process.env.NAVY_EXTERNAL_IP = '192.168.1.10';
            _context.t0 = _chai.expect;
            _context.next = 4;
            return (0, _externalIp.getExternalIP)();

          case 4:
            _context.t1 = _context.sent;
            (0, _context.t0)(_context.t1).to.equal('192.168.1.10');

            delete process.env.NAVY_EXTERNAL_IP;

          case 7:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  })));

  it('should return correct extract from DOCKER_HOST if set', (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            process.env.DOCKER_HOST = 'tcp://192.168.1.12:2375';
            _context2.t0 = _chai.expect;
            _context2.next = 4;
            return (0, _externalIp.getExternalIP)();

          case 4:
            _context2.t1 = _context2.sent;
            (0, _context2.t0)(_context2.t1).to.equal('192.168.1.12');

            delete process.env.DOCKER_HOST;

          case 7:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  })));

  it('should resolve the hostname from DOCKER_HOST if it isn\'t an ipv4 address', (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            process.env.DOCKER_HOST = 'tcp://localhost:2375';
            _context3.t0 = _chai.expect;
            _context3.next = 4;
            return (0, _externalIp.getExternalIP)();

          case 4:
            _context3.t1 = _context3.sent;
            (0, _context3.t0)(_context3.t1).to.equal('127.0.0.1');


            process.env.DOCKER_HOST = 'tcp://testfoo.192.168.1.13.nip.io:2375';
            _context3.t2 = _chai.expect;
            _context3.next = 10;
            return (0, _externalIp.getExternalIP)();

          case 10:
            _context3.t3 = _context3.sent;
            (0, _context3.t2)(_context3.t3).to.equal('192.168.1.13');

            delete process.env.DOCKER_HOST;

          case 13:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  })));
});