'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.execAsync = execAsync;

var _child_process = require('child_process');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('navy:exec');

function execAsync(command) {
  var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var callback = arguments[2];
  var opts = arguments[3];

  return new _promise2.default(function (resolve, reject) {
    var cmd = command + ' ' + args.join(' ');

    debug('Executing ' + cmd);

    var childProcess = (0, _child_process.exec)(cmd, opts, function (err, stdout, stderr) {
      if (err) {
        reject(err);
      } else {
        resolve(stdout.toString());
      }
    });

    childProcess.stdout.on('data', function (line) {
      return debug('out: ' + line.toString());
    });
    childProcess.stderr.on('data', function (line) {
      return debug('err: ' + line.toString());
    });

    if (callback) {
      callback(childProcess);
    }
  });
}