'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getExternalIP = exports.dnsLookup = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var dnsLookup = exports.dnsLookup = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(hostname) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return new _promise2.default(function (resolve, reject) {
              _dns2.default.lookup(hostname, null, function (err, ip, ipFamily) {
                if (err || ipFamily !== IPV4_FAMILY) {
                  reject(new Error('Failed to lookup hostname "' + hostname + '"'));
                } else {
                  resolve(ip);
                }
              });
            });

          case 2:
            return _context.abrupt('return', _context.sent);

          case 3:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function dnsLookup(_x) {
    return _ref.apply(this, arguments);
  };
}();

var getExternalIP = exports.getExternalIP = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(ipInConfig) {
    var dockerHost, ip;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            dockerHost = process.env.DOCKER_HOST;

            // DEPRECATED use NAVY_EXTERNAL_IP instead

            if (!process.env.NAVY_HOST) {
              _context2.next = 3;
              break;
            }

            return _context2.abrupt('return', process.env.NAVY_HOST);

          case 3:
            if (!process.env.NAVY_EXTERNAL_IP) {
              _context2.next = 5;
              break;
            }

            return _context2.abrupt('return', process.env.NAVY_EXTERNAL_IP);

          case 5:
            if (!ipInConfig) {
              _context2.next = 9;
              break;
            }

            _context2.next = 8;
            return dnsLookup(ipInConfig);

          case 8:
            return _context2.abrupt('return', _context2.sent);

          case 9:
            if (!(dockerHost && dockerHost.indexOf('tcp://') !== -1)) {
              _context2.next = 16;
              break;
            }

            // OSX with docker-machine, or a remote docker
            // dockerHost will be formatted like:
            // tcp://_._._._:_
            // We only care about the IP address

            ip = dockerHost.substring('tcp://'.length);

            ip = ip.substring(0, ip.lastIndexOf(':')).trim();
            _context2.next = 14;
            return dnsLookup(ip);

          case 14:
            ip = _context2.sent;
            return _context2.abrupt('return', ip);

          case 16:
            return _context2.abrupt('return', '127.0.0.1');

          case 17:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function getExternalIP(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

var _dns = require('dns');

var _dns2 = _interopRequireDefault(_dns);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var IPV4_FAMILY = 4;