'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _simpleDockerRegistryClient = require('simple-docker-registry-client');

var _registryClient = require('./registry-client');

var _dockerClient = require('./docker-client');

var _dockerClient2 = _interopRequireDefault(_dockerClient);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(imageWithTag, currentImageId, navyFile) {
    var imageConfig, currentImageContainerId, image, client, manifest, lastLayer;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _dockerClient2.default.getImage(currentImageId).inspect();

          case 2:
            imageConfig = _context.sent;
            currentImageContainerId = imageConfig.ContainerConfig.Image;
            image = (0, _simpleDockerRegistryClient.imageFromImageWithTag)(imageWithTag);
            _context.next = 7;
            return (0, _registryClient.getRegistryClient)(image, navyFile);

          case 7:
            client = _context.sent;
            manifest = void 0;
            _context.prev = 9;
            _context.next = 12;
            return client.request((0, _simpleDockerRegistryClient.localImageFromImage)(image) + '/manifests/' + (0, _simpleDockerRegistryClient.tagFromImageWithTag)(imageWithTag));

          case 12:
            manifest = _context.sent;
            _context.next = 20;
            break;

          case 15:
            _context.prev = 15;
            _context.t0 = _context['catch'](9);

            if (!(_context.t0.body && _context.t0.body.errors[0].code === 'MANIFEST_UNKNOWN')) {
              _context.next = 19;
              break;
            }

            return _context.abrupt('return', 'UNKNOWN_REMOTE');

          case 19:
            return _context.abrupt('return', 'UNKNOWN_ERROR');

          case 20:
            lastLayer = JSON.parse(manifest.history[0].v1Compatibility);
            return _context.abrupt('return', lastLayer.container_config.Image !== currentImageContainerId);

          case 22:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[9, 15]]);
  }));

  function hasUpdate(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  }

  return hasUpdate;
}();

module.exports = exports.default;