'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRegistryClient = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

// the url which docker stores in .docker/config.json for auth

var getDockerUserConfig = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var rawConfig, config;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            (0, _invariant2.default)(process.env.HOME, 'NO_HOME_DIRECTORY: No home directory available');

            _context.prev = 1;
            _context.next = 4;
            return _fs2.default.readFileAsync(_path2.default.join(process.env.HOME, '.docker', 'config.json'));

          case 4:
            rawConfig = _context.sent;
            config = JSON.parse(rawConfig);
            return _context.abrupt('return', config);

          case 9:
            _context.prev = 9;
            _context.t0 = _context['catch'](1);
            return _context.abrupt('return', null);

          case 12:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[1, 9]]);
  }));

  return function getDockerUserConfig() {
    return _ref.apply(this, arguments);
  };
}();

var getRegistryClient = exports.getRegistryClient = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(image, navyFile) {
    var registry, opts, auth;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            registry = registryFromImage(image);
            opts = {
              registry: 'https://' + registry,
              allowUnauthorized: navyFile && navyFile.ignoreUnauthorizedRequestsForRegistries && navyFile.ignoreUnauthorizedRequestsForRegistries.indexOf(registry) !== -1

              // try and work out auth
            };
            _context2.t0 = getAuthForRegistry;
            _context2.t1 = registry;
            _context2.next = 6;
            return getDockerUserConfig();

          case 6:
            _context2.t2 = _context2.sent;
            auth = (0, _context2.t0)(_context2.t1, _context2.t2);

            opts.credentials = credentialsFromAuth(auth);

            return _context2.abrupt('return', {
              request: function request(url) {
                return (0, _simpleDockerRegistryClient.registryRequest)(url, opts);
              }
            });

          case 10:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function getRegistryClient(_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();

exports.getAuthForRegistry = getAuthForRegistry;
exports.registryFromImage = registryFromImage;
exports.credentialsFromAuth = credentialsFromAuth;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _simpleDockerRegistryClient = require('simple-docker-registry-client');

var _fs = require('./fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_REGISTRY = 'registry-1.docker.io'; // docker v2 registry URL
var DEFAULT_REGISTRY_AUTH = 'https://index.docker.io/v1/';function getAuthForRegistry(registry, dockerUserConfig) {
  if (registry === DEFAULT_REGISTRY) {
    registry = DEFAULT_REGISTRY_AUTH;
  }

  if (dockerUserConfig && dockerUserConfig.auths && dockerUserConfig.auths[registry]) {
    return dockerUserConfig.auths[registry];
  }

  return null;
}

function registryFromImage(image) {
  var parsedRegistry = image.match(/([a-zA-Z0-9-.:]+)\/[a-zA-Z0-9-]+\/[a-zA-Z0-9-]+/);
  var registry = parsedRegistry != null && parsedRegistry.length > 1 ? parsedRegistry[1] : DEFAULT_REGISTRY;

  return registry;
}

function credentialsFromAuth(auth) {
  if (auth && auth.auth) {
    (0, _invariant2.default)(auth.auth.match(/^([A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{4}|[A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{2}==)$/) != null, 'DOCKER_CONFIG_INVALID_AUTH_BASE64: Invalid base64 string in docker/config.json for registry authentication');

    var decoded = Buffer.from(auth.auth, 'base64').toString();
    var parts = decoded.split(':');

    return {
      username: parts[0],
      password: parts[1]
    };
  }

  return null;
}