'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createUrlForService = exports.createHostForService = exports.getNIPSubdomain = undefined;

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getNIPSubdomain = exports.getNIPSubdomain = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(externalIP) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (isValidIpv4Addr(externalIP)) {
              _context.next = 2;
              break;
            }

            return _context.abrupt('return', '127.0.0.1.' + BASE);

          case 2:
            return _context.abrupt('return', externalIP + '.' + BASE);

          case 3:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getNIPSubdomain(_x) {
    return _ref.apply(this, arguments);
  };
}();

var createHostForService = exports.createHostForService = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(service, navyNormalisedName, externalIP) {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.t0 = service + '.' + navyNormalisedName + '.';
            _context2.t1 = process.env.NAVY_EXTERNAL_SUBDOMAIN;

            if (_context2.t1) {
              _context2.next = 6;
              break;
            }

            _context2.next = 5;
            return getNIPSubdomain(externalIP);

          case 5:
            _context2.t1 = _context2.sent;

          case 6:
            _context2.t2 = _context2.t1;
            return _context2.abrupt('return', _context2.t0 + _context2.t2);

          case 8:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function createHostForService(_x2, _x3, _x4) {
    return _ref2.apply(this, arguments);
  };
}();

var createUrlForService = exports.createUrlForService = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(service, navyNormalisedName, externalIP) {
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return createHostForService(service, navyNormalisedName, externalIP);

          case 2:
            _context3.t0 = _context3.sent;
            return _context3.abrupt('return', 'http://' + _context3.t0);

          case 4:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function createUrlForService(_x5, _x6, _x7) {
    return _ref3.apply(this, arguments);
  };
}();

exports.getUrlFromService = getUrlFromService;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE = 'nip.io';

function isValidIpv4Addr(ip) {
  return (/^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/g.test(ip)
  );
}

function getUrlFromService(service) {
  if (!service || !service.raw || !service.raw.Config || !service.raw.Config.Env) {
    return null;
  }

  var env = service.raw.Config.Env;

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)(env), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var envVar = _step.value;

      if (envVar.indexOf('VIRTUAL_HOST=') === 0) {
        return 'http://' + envVar.substring('VIRTUAL_HOST='.length);
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return null;
}