'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = table;

var _pad = require('pad');

var _pad2 = _interopRequireDefault(_pad);

var _stripAnsi = require('strip-ansi');

var _stripAnsi2 = _interopRequireDefault(_stripAnsi);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function table(rows) {
  if (rows.length === 0) {
    return '';
  }

  var cols = rows[0];
  var colSizes = cols.map(function (col, colIndex) {
    return rows.reduce(function (currentSize, row) {
      return currentSize = Math.max(currentSize, (0, _stripAnsi2.default)(row[colIndex] || '').length);
    }, 0) + 2;
  });

  return rows.map(function (row) {
    return row.map(function (col, colIndex) {
      return (0, _pad2.default)(col || '', colSizes[colIndex], { colors: true });
    }).join('');
  }).join('\n');
}
module.exports = exports.default;